/**
 ** sparkInterfaceTaskCodels.cc
 **
 ** Codels called by execution task sparkInterfaceTask
 **
 ** Author: Akin Sisbot
 ** Date: Aug 10
 **
 **/

#include <portLib.h>

#include "server/sparkHeader.h"
#include "sparkm3d.h"



/* sparkUpdateInterfaceMain  -  codel EXEC of UpdateInterface
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
sparkUpdateInterfaceMain(int *report)
{
  //  SDI_F->InterfaceState.updating = GEN_TRUE;
  //   if(SDI_F->State.planning || SDI_F->State.updating){
  //     SDI_F->InterfaceState.updating = GEN_FALSE;
  //     return EXEC;
  //   }
  
  if(SDI_F->p3d.enableGraphic){
    //  GENOM_UNLOCK_SDI;   
    g3d_draw_allwin_active();
    g3d_refresh_allwin_active();
    
    if(SDI_F->interfaceParams.saveInterface){
      g3d_screenshot((char *)"Move3D");    
    }
    
    //  GENOM_LOCK_SDI;
    //   SDI_F->InterfaceState.updating = GEN_FALSE;
    *report = OK;
    return EXEC;
  }
  else{
    printf("Graphics not enabled\n");
    //   SDI_F->InterfaceState.updating = GEN_FALSE;
    *report = S_spark_INTERFACE_DISABLED;
    return ETHER;
  }
}


/* sparkChangeCameraPosMain  -  codel EXEC of ChangeCameraPos
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
sparkChangeCameraPosMain(SPARK_CAM_POS *camPos, int *report)
{
  G3D_Window *window = g3d_get_win_by_name("Move3D");
  
  if(!SDI_F->p3d.enableGraphic){
    printf("The Interface is disabled. Cannot change the camera position.\n");
    *report = S_spark_INTERFACE_DISABLED;
    return ETHER;
  }
  
  if(window){
    printf("Changing camera position of the window: %s\n",window->name);
    g3d_set_win_camera(window->vs, camPos->xdest, camPos->ydest, camPos->zdest,
		       camPos->dist, camPos->hrot, camPos->vrot, 0.0, 0.0, 1.0);
    window->vs.displayFloor = TRUE;
  }
  
  *report = OK;
  return ETHER;
}



/* sparkSetInterfaceParamsMain  -  codel EXEC of SetInterfaceParams
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
sparkSetInterfaceParamsMain(SPARK_INTERFACE_PARAMS *interfaceParams, int *report)
{
  G3D_Window *win = g3d_get_win_by_name("Move3D");
  
  if(!SDI_F->p3d.enableGraphic){
    printf("The Interface is disabled.\n");
    *report = S_spark_INTERFACE_DISABLED;
    return ETHER;
  }
  
  if(!interfaceParams->floor) 
    win->vs.displayFloor = FALSE;
  else 
    win->vs.displayFloor = TRUE;
  
  if(!interfaceParams->walls) 
    win->vs.displayWalls = FALSE;
  else 
    win->vs.displayWalls = TRUE;
  
  if(!interfaceParams->shadows) 
    win->vs.displayShadows = FALSE;
  else 
    win->vs.displayShadows = TRUE;

 if(!interfaceParams->tiles) 
    win->vs.displayTiles = FALSE;
  else 
    win->vs.displayTiles = TRUE;

 if(!interfaceParams->antialiasing) 
    win->vs.enableAntialiasing = FALSE;
  else 
    win->vs.enableAntialiasing = TRUE;
  
  *report = OK;
  return ETHER;
}
