/*****************************************************************************
*
* Emrah Akin Sisbot
* Aug 10 
*
* File : sparkm3d.h
* Brief   :
*
******************************************************************************/

#ifndef SPARKM3D_H
#define SPARKM3D_H

/*----------------------------------------------------------------------------
  INCLUDE
-----------------------------------------------------------------------------*/

#include "Util-pkg.h"
#include "P3d-pkg.h"
#include "Planner-pkg.h"
#include "Localpath-pkg.h"
#include "Collision-pkg.h"
#include "Graphic-pkg.h"
#include "Hri_planner-pkg.h"
#include "Move3d-pkg.h"

#include <sys/time.h>

#ifdef ORO
#include "sparkOro.h"
#endif

#define D2D(x1,y1,x2,y2) (sqrt((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1)))
#define D3D(x1,y1,z1,x2,y2,z2) (sqrt((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1)+(z2-z1)*(z2-z1)))

#define COND_PRINT(cond,str)  if( cond ) printf str
#define DEBUG_PRINTF(level,str)  if(SDI_F->State.debug_mode && (level <= SDI_F->State.debug_mode) ) printf str

extern hri_bitmapset * BTSET;
extern hri_bitmapset * ACBTSET; // ACBTSET is a global variable used for mightabilities
extern FL_FORM *MAIN_FORM;

extern p3d_env * gEnv;
extern HRI_AGENT * gRobot;
extern hri_bitmapset * gBtset;
extern hri_gik * gGik;
extern HRI_AGENTS * gAgents;
extern int Mightability_Maps_Initialized;

/*----------------------------------------------------------------------------
  STRUCTURES
  -----------------------------------------------------------------------------*/

typedef struct {
  int PositionAv;
  int HeadAv;
  double Head[6];
  int RightHandAv;
  double RightHand[3];
  int LeftHandAv;
  double LeftHand[3];
} mhp_agent_sensor_position;
  

/*----------------------------------------------------------------------------
  PROTOTYPE
-----------------------------------------------------------------------------*/

extern int timeval_subtract(struct timeval *result, struct timeval *t2, struct timeval *t1);


/* extern gik_task_joints * mhp_create_defaut_gik_tasks( void ); */
/* extern ACTIVITY_EVENT mhp_initialize_manipulation(int *report); */
/* extern ACTIVITY_EVENT mhp_initialize_navigation(int *report); */
/* extern int mhp_object_visibility_state(p3d_rob * object, HRI_AGENT *agent,  */
/* 				       double elevation, double azimuth, */
/* 				       int VisThr, */
/* 				       MHP_VISIBILITY *visibility); */
/* extern int mhp_object_reachability_state(p3d_rob * object, HRI_AGENT *agent,  */
/* 					 MHP_REACHABILITY *reachability); */

/* extern ENUM_MHP_PLRELATION mhp_placement_relation(p3d_rob *source_obj, p3d_rob *target_obj); */

/* #ifdef HRP2 */
/* extern void mhp_Arm2ConfigPt( ghrp2_config_t *cfg, configPt m3dconfig); */
/* #elif defined(JIDO) */
/* extern void mhp_Arm2ConfigPt(Gb_q7 *gbconfig, configPt m3dconfig); */
/* #endif */

/* #ifdef ORO */
/* #include "mhpOro.h" */
/* #endif */


#endif
